//+------------------------------------------------------------------+
//|                                                 KositBablo20.mq5 |
//|                                                          Crucian |
//|                            https://www.mql5.com/ru/users/crucian |
//+------------------------------------------------------------------+
#property copyright "Crucian"
#property link      "https://www.mql5.com/ru/users/crucian"
#property version   "1.11"

#include <Trade\Trade.mqh> //      ,  CTrade
#include <Trade\AccountInfo.mqh> //     - AccountInfo
//---   / external variables -----------------------------------------

input string s1="====   (    )===="; //    ================================
input ENUM_TIMEFRAMES     TF_graph                        = PERIOD_H1;                //                                             
input int                 percent_risk                    = 10;                       // % 
input int                 koef_lot                        = 10;                       //    (1, 10, 100)   
input bool                close_at_the_opposite_signal    = false;                    //     ?
input int                 close_a_profit                  = 0;                        //     , . =0 
input int                 Bezubytok                       = 0;                        //    , .  =0
input bool                at_new_signals                  = true;                     //        
input string s2="=================================================================="; // ===========================================================
input string s3="================     ==================="; //     =============================
input bool                resolve_on_buy                  = true;                     //    ?
input int                 TP_long                         = 200;                      //     
input int                 SL_long                         = 100;                      //      
input string s4="============  Moving Average ==============";    //   Moving Average ======================
input string s5="--------------  Moving Average----------------";              //  Moving Average --------------------
input int                 ma_fast_period_long             = 4;                        //   
input int                 ma_fast_shift_long              = 7;                        //     
input ENUM_MA_METHOD      ma_fast_method_long             = MODE_SMA;                 //   
input ENUM_APPLIED_PRICE  ma_fast_applied_price_long      = PRICE_CLOSE;              //  
input string s6="--------------  Moving Average----------------";            //  Moving Average ------------------
input int                 ma_slow_period_long             = 15;                       //   
input int                 ma_slow_shift_long              = 7;                        //     
input ENUM_MA_METHOD      ma_slow_method_long             = MODE_SMA;                 //   
input ENUM_APPLIED_PRICE  ma_slow_applied_price_long      = PRICE_CLOSE;              //    

input string s7="=======  Relative Strength Index ==========";    //   Relative Strength Index===========
input string s9="--------------  RSI ----------------";                        //  RSI --------------------------
input int                 level_oversold_RSI_fast         = 35;                       //   , %
input ENUM_TIMEFRAMES     TF_RSI_fast_long                = PERIOD_H1;                //   RSI 
input int                 RSI_fast_period_long            = 15;                       //   
input ENUM_APPLIED_PRICE  RSI_fast_applied_price_long     = PRICE_CLOSE;              //    
input string s10="-------------  RSI ---------------";                       //  RSI -------------------------
input int                 level_oversold_RSI_slow         = 50;                       //   , % 
input ENUM_TIMEFRAMES     TF_RSI_slow_long                = PERIOD_H4;                //   RSI
input int                 RSI_slow_period_long            = 11;                       //   
input ENUM_APPLIED_PRICE  RSI_slow_applied_price_long     = PRICE_CLOSE;              //   
input string s11="================================================================";  // =============================================================
input string s12="==============     ==================";  //     ============================== 
input bool                resolve_on_sell                 = true;                     //    ?  
input int                 TP_short                        = 165;                      //      
input int                 SL_short                        = 120;                      //      
input string s13="============  Moving Average=============";     //   Moving Average ========================
input string s14="--------------  Moving Average----------------";             //  Moving Average -----------------
input int                 ma_fast_period_short            = 8;                        //   
input int                 ma_fast_shift_short             = 7;                        //     
input ENUM_MA_METHOD      ma_fast_method_short            = MODE_SMA;                 //   
input ENUM_APPLIED_PRICE  ma_fast_applied_price_short     = PRICE_CLOSE;              //   
input string s15="--------------  Moving Average----------------";           //  Moving Average ----------------
input int                 ma_slow_period_short            = 12;                       //   
input int                 ma_slow_shift_short             = 7;                        //     
input ENUM_MA_METHOD      ma_slow_method_short            = MODE_SMA;                 //   
input ENUM_APPLIED_PRICE  ma_slow_applied_price_short     = PRICE_CLOSE;              //   

input string s16="=======  Relative Strength Index==========";    //    Relative Strength Index============
input string s17="--------------  RSI ----------------";                       //  RSI -----------------------------
input int                 level_overbought_RSI_fast       = 50;                       //   , %
input ENUM_TIMEFRAMES     TF_RSI_fast_short               = PERIOD_H1;                //   RSI
input int                 RSI_fast_period_short           = 9;                        //   
input ENUM_APPLIED_PRICE  RSI_fast_applied_price_short    = PRICE_CLOSE;              //    
input string s18="-------------  RSI ---------------";                       //  RSI ----------------------------
input int                 level_overbought_RSI_slow       = 55;                       //   , % 
input ENUM_TIMEFRAMES     TF_RSI_slow_short               = PERIOD_H4;                //   RSI
input int                 RSI_slow_period_short           = 48;                       //   
input ENUM_APPLIED_PRICE  RSI_slow_applied_price_short    = PRICE_CLOSE;              //   
input string s20="----------------------------------------------------------------";  // ----------------------------------------------------------

//--- 
CTrade            trade;                         //   CTrade,   trade    
CAccountInfo      account;                       //   CAccountInfo,   account    
MqlTick           latest_price;                  //     

int coef=1;           //  4-   
ulong POS_id;         //  
double Ask1,Bid1;     //  Bid  Ask

//  
int  RSI_fast_long, RSI_slow_long, RSI_fast_short, RSI_slow_short,
      MA_fast_long, MA_slow_long,  MA_fast_short,  MA_slow_short;
      
double RSI_fast_long_Val[], RSI_slow_long_Val[], RSI_fast_short_Val[], RSI_slow_short_Val[],
       MA_fast_long_Val[],  MA_slow_long_Val[],  MA_fast_short_Val[],  MA_slow_short_Val[];

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
// ---   
//   
   MA_fast_long=iMA( _Symbol, TF_graph , ma_fast_period_long, ma_fast_shift_long, ma_fast_method_long, ma_fast_applied_price_long );
   MA_slow_long=iMA( _Symbol, TF_graph , ma_slow_period_long, ma_slow_shift_long, ma_slow_method_long, ma_slow_applied_price_long );
   RSI_fast_long=iRSI( _Symbol, TF_RSI_fast_long, RSI_fast_period_long, RSI_fast_applied_price_long );
   RSI_slow_long=iRSI( _Symbol, TF_RSI_slow_long, RSI_slow_period_long, RSI_slow_applied_price_long );  
 //  
   MA_fast_short=iMA( _Symbol, TF_graph , ma_fast_period_short, ma_fast_shift_short, ma_fast_method_short, ma_fast_applied_price_short );
   MA_slow_short=iMA( _Symbol, TF_graph , ma_slow_period_short, ma_slow_shift_short, ma_slow_method_short, ma_slow_applied_price_short );
   RSI_fast_short=iRSI( _Symbol, TF_RSI_fast_short, RSI_fast_period_short, RSI_fast_applied_price_short );
   RSI_slow_short=iRSI( _Symbol, TF_RSI_slow_short, RSI_slow_period_short, RSI_slow_applied_price_short ); 

//---  ,      Invalid Handle
   if((MA_fast_long<0) || (MA_slow_long<0)|| (MA_fast_short<0) || (MA_slow_short<0)  )
     {
      Alert("Error creating indicators (Moving Average) - the number of errors: ",GetLastError(),"!!");
      return(-1);
     }    
   if((RSI_fast_long<0) || (RSI_slow_long<0)|| (RSI_fast_short<0) || (RSI_slow_short<0)  )
     {
      Alert("Error creating indicators (Relative Strength Index) - the number of errors: ",GetLastError(),"!!");
      return(-1);
     }  
 //         
    if(_Digits==3 || _Digits==5)
           { coef=10;
           }
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  //---      
     IndicatorRelease(MA_fast_long);
     IndicatorRelease(MA_slow_long);   
     IndicatorRelease(RSI_fast_long);
     IndicatorRelease(RSI_fast_long);
     IndicatorRelease(MA_fast_short);
     IndicatorRelease(MA_slow_short);   
     IndicatorRelease(RSI_fast_short);
     IndicatorRelease(RSI_fast_short);    
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {  
//---    
   ArraySetAsSeries(RSI_fast_long_Val,true);
   ArraySetAsSeries(RSI_slow_long_Val,true);
   ArraySetAsSeries(RSI_fast_short_Val,true);
   ArraySetAsSeries(RSI_slow_short_Val,true);
   ArraySetAsSeries(MA_fast_long_Val,true);
   ArraySetAsSeries(MA_slow_long_Val,true);
   ArraySetAsSeries(MA_fast_short_Val,true);
   ArraySetAsSeries(MA_slow_short_Val,true);
   
//---    
     if(CopyBuffer(RSI_fast_long,0,0,3,RSI_fast_long_Val)<0)
      {
      Alert("     RSI / Error copying buffers fast indicator RSI - error number:",GetLastError(),"!!");
      return;
      }   
    if(CopyBuffer(RSI_slow_long,0,0,3,RSI_slow_long_Val)<0)
      {
      Alert("     RSI / Error copying buffers slow indicator RSI - error number:",GetLastError(),"!!");
      return;
      }   
    if(CopyBuffer(RSI_fast_short,0,0,3,RSI_fast_short_Val)<0)
      {
      Alert("      RSI / Error copying buffers fast indicator RSI - error number:",GetLastError(),"!!");
      return;
      }   
    if(CopyBuffer(RSI_slow_short,0,0,3,RSI_slow_short_Val)<0)
      {
      Alert("     RSI / Error copying buffers slow indicator RSI - error number:",GetLastError(),"!!");
      return;
      }  
 //-----------------    
     if(CopyBuffer(MA_fast_long,0,0,3,MA_fast_long_Val)<0)
      {
      Alert("     MA / Error copying buffers fast indicator MA - error number:",GetLastError(),"!!");
      return;
      }   
    if(CopyBuffer(MA_slow_long,0,0,3,MA_slow_long_Val)<0)
      {
      Alert("     MA / Error copying buffers slow indicator MA - error number:",GetLastError(),"!!");
      return;
      }   
    if(CopyBuffer(MA_fast_short,0,0,3,MA_fast_short_Val)<0)
      {
      Alert("      MA / Error copying buffers fast indicator MA - error number:",GetLastError(),"!!");
      return;
      }   
    if(CopyBuffer(MA_slow_short,0,0,3,MA_slow_short_Val)<0)
      {
      Alert("     MA / Error copying buffers slow indicator MA - error number:",GetLastError(),"!!");
      return;
      }          
 //+----------------------------------------        ---------- 
   static datetime Old_Time;   //     Old_Time
   datetime New_Time[1];       //    New_Time   
   bool IsNewBar=false;        //   IsNewBar  0
//---       New_Time[0]
   int copied=CopyTime(_Symbol,TF_graph ,0,1,New_Time);
   if(copied>0) //  ?
     {
      if(Old_Time!=New_Time[0]) //         
        {
         IsNewBar=true;     //    =  (1)
         if(MQL5InfoInteger(MQL5_DEBUGGING)) Print("The new bar",New_Time[0],"Old bar",Old_Time); //    
         Old_Time=New_Time[0];   //   
        }
     }
   else
     {
      Alert("Error copying time, error number =",GetLastError());
      ResetLastError();
      return;
     }
//---            
   if(IsNewBar==false) // IsNewBar = 
     {
     return; //  IsNewBar != , ,   OnTick()
     }  
     
//---     boolean --------------------------------------------------------------------------------------------
//--- Buy_Condition +++++++++++++++++++++  
bool Buy_Condition_MA = ( MA_fast_long_Val[1] > MA_fast_long_Val[2] && MA_slow_long_Val[1] < MA_slow_long_Val[2] && MA_fast_long_Val[0] > MA_slow_long_Val[0] ); 
          //   ,   ,     >   (- )         
bool Buy_Condition_RSI = ( RSI_fast_long_Val[1] <  level_oversold_RSI_fast && RSI_slow_long_Val[1] < level_oversold_RSI_slow ); 
          //  RSI   RSI   ,    "  "
          
//--- Sell_Condition +++++++++++++++++++++  
bool Sell_Condition_MA = ( MA_fast_short_Val[1] < MA_fast_short_Val[2] && MA_slow_short_Val[1] > MA_slow_short_Val[2] && MA_fast_short_Val[0] < MA_slow_short_Val[0] ); 
          //   ,   ,     <   (-          
bool Sell_Condition_RSI = ( RSI_fast_short_Val[1] >  level_overbought_RSI_fast && RSI_slow_short_Val[1] > level_overbought_RSI_slow ); 
          //  RSI   RSI   ,    "  "          
          
 //--- ,        --------------------------------------------------------------------- 
     bool selected=PositionSelect(_Symbol); //      
              if(selected) //      
              {    //     
                        long pos_id               =   PositionGetInteger(POSITION_IDENTIFIER);                //   () 
                        double price              =   PositionGetDouble(POSITION_PRICE_OPEN);                 //   
                        ENUM_POSITION_TYPE P_type =   (ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);  //   
                        double VOLUME             =   PositionGetDouble(POSITION_VOLUME);                     //   
                        double current_profit     =   PositionGetDouble(POSITION_PROFIT);                     //   
                        double current_price      =   PositionGetDouble(POSITION_PRICE_CURRENT);              //    
                     
                      if(!SymbolInfoTick(_Symbol,latest_price))   //        MqlTick
                         {
                        Alert("    - :",GetLastError(),"!!");
                         return;//
                         }else{   
                        Bid1 =  NormalizeDouble(latest_price.bid,_Digits); //   Bid 
                        Ask1 =  NormalizeDouble(latest_price.ask,_Digits); //   Ask 
                              }
                    if ( close_at_the_opposite_signal ) //     ?
                       {
                     
                       if (P_type==0) //    
                         {
                          if ( Sell_Condition_MA && Sell_Condition_RSI )   //        
                             {
                             if ( close_a_profit !=0)   //    ?
                               { 
                                if ( (Bid1 - price)> NormalizeDouble (close_a_profit*coef*_Point,_Digits) && current_profit > 0 ) 
                                     // (  Bid -  ) >       ( )    
                                  {
                                 PositionClose( pos_id ); //   c  
                                  }
                               } else {
                                       PositionClose( pos_id ); //  ,   , ..    
                                      }
                              }     
                          }                                           
                       if (P_type==1) //    
                          {
                          if ( Buy_Condition_MA && Buy_Condition_RSI )   //        
                              {
                              if ( close_a_profit !=0)   //    ?
                               { 
                                if ( ( price - Ask1 )> NormalizeDouble (close_a_profit*coef*_Point,_Digits) && current_profit > 0 )  
                                     // (  -  ) >       ( )                                        
                                  {
                                 PositionClose( pos_id ); //   c 
                                  }
                               } else {
                                       PositionClose( pos_id ); //  ,   , ..    
                                      }
                              }     
                          } 
                       }                        
                       
                  if ( Bezubytok >0 && POS_id != pos_id ) //        /,     /    
                     {
                       if ((price  - Bid1) > NormalizeDouble((Bezubytok*2*coef)*_Point,_Digits) && P_type== 1 ) //        2*Bezubytok?,  ?
                        {                      
                           ModificationPosition (pos_id, NormalizeDouble(Bid1 + Bezubytok *coef*_Point,_Digits),NormalizeDouble(Bid1 - TP_short*coef*_Point,_Digits) ); //   
                        }
                       if ( ( Ask1 - price ) > NormalizeDouble((Bezubytok*2*coef)*_Point,_Digits)&& P_type== 0 ) //        2*Bezubytok?,  ?
                        {
                          ModificationPosition(pos_id,NormalizeDouble(Ask1 - Bezubytok*coef*_Point,_Digits),NormalizeDouble(Ask1 + TP_long*coef*_Point,_Digits) ); //    
                        } 
                     }      
                       
                       
            if ( at_new_signals ) //    /   
               {
                if ( Buy_Condition_MA && Buy_Condition_RSI && resolve_on_buy )    //       ,   ? 
                       {
                         Long_Position_Open(GetSizeLot(percent_risk));  //    ,   
                       }                      
                     if ( Sell_Condition_MA && Sell_Condition_RSI && resolve_on_sell )  //       ,   ? 
                       {
                         Short_Position_Open(GetSizeLot(percent_risk));  //    ,   
                       }
                     } 
                                 
              } else {  //   ,        ,  ,   ,  /,
                       
                              
                     if ( Buy_Condition_MA && Buy_Condition_RSI && resolve_on_buy && !PositionSelect(_Symbol) )    //       ,   ?,      
                       {
                         Long_Position_Open(GetSizeLot(percent_risk)); //    
                       }                      
                     if ( Sell_Condition_MA && Sell_Condition_RSI && resolve_on_sell && !PositionSelect(_Symbol) )  //       ,   ?,       
                       {
                         Short_Position_Open(GetSizeLot(percent_risk)); //    
                       }
                     }                                                           
 }  // +++++++++++++++++++++++++++++++++  tick function
                   
//+-----------------------------------------------------------------------+
//|                                                 |
//+-----------------------------------------------------------------------+                      
 void Long_Position_Open(double lot_value)
 {   
    double lot = NormalizeLot(lot_value);                 //   
 
   //---        MqlTick
   if(!SymbolInfoTick(_Symbol,latest_price))
     {
      Alert("    - :",GetLastError(),"!!");
      return;//
     } 
      double Ask =  NormalizeDouble(latest_price.ask,_Digits); //   Ask  
       
    if(account.FreeMarginCheck(_Symbol,ORDER_TYPE_BUY,lot,Ask)<0.0)  //     
   {            printf("     !!. Free Margin = %f",account.FreeMargin());
         return;
   }                             
//---   
if(
      trade.PositionOpen(
           _Symbol,                                                 //  
           ORDER_TYPE_BUY,                                          //   
           lot,                                                     //  
           Ask ,                                                    //   ask 
           NormalizeDouble(Ask - SL_long*coef*_Point,_Digits),      // Stop Loss
           NormalizeDouble(Ask + TP_long*coef*_Point,_Digits),      // Take Profit 
           " "          )                                           //  
  )printf("   %s ",_Symbol);
  else           {
                  printf("      %s : '%s'",_Symbol,trade.ResultComment());
                 }                                                     
}  
//+-----------------------------------------------------------------------+
//|                                                |
//+-----------------------------------------------------------------------+                      
 void Short_Position_Open(double lot_value)
 {   
    double lot = NormalizeLot(lot_value);                 //  

   //---        MqlTick
   if(!SymbolInfoTick(_Symbol,latest_price))
     {
      Alert("    - :",GetLastError(),"!!");
      return;
     } 
   double Bid =  NormalizeDouble(latest_price.bid,_Digits); //   Bid 
   
    if(account.FreeMarginCheck(_Symbol,ORDER_TYPE_SELL,lot,Bid)<0.0)  //     
   {            printf("     !!. Free Margin = %f",account.FreeMargin());
         return;
   }        
                   
//---   
if(
      trade.PositionOpen(
           _Symbol,                                                 //  
           ORDER_TYPE_SELL,                                         //   
           lot,                                                     //  
           Bid ,                                                    //   ask 
           NormalizeDouble(Bid + SL_short*coef*_Point,_Digits),     // Stop Loss
           NormalizeDouble(Bid - TP_short*coef*_Point,_Digits),     // Take Profit 
           " "          )                                           //  
  )printf("   %s ",_Symbol);
  else           {
                  printf("      %s : '%s'",_Symbol,trade.ResultComment());
                 }   
}  
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void PositionClose(ulong id)
  {
Print("        !");
 
//---   
if(
      trade.PositionClose(
           id,                                                 //  
           10*coef                                             //    
                         )                                           
  )printf("  %s ",_Symbol);
  else           {
                  printf("     %s : '%s'",_Symbol,trade.ResultComment());
                 }   
  } 
  
//+------------------------------------------------------------------+
//|  (   )               |
//+------------------------------------------------------------------+
void ModificationPosition  (ulong id,double sl,double tp)
{
if(
      trade.PositionModify(
           id,                                                 //  
           sl,                                                 // Stop Loss
           tp                                                  // Take Profit                                                     
                          )                                           
  ){printf(" a",_Symbol); POS_id=id;       //           
   } else           {
                  printf("     %s : '%s'",_Symbol,trade.ResultComment());
                    } 
}                    
//+------------------------------------------------------------------+
//|      (  ) | 
//+------------------------------------------------------------------+  
double GetSizeLot(int LotsPercent)
  {
   double dLot;
   dLot=(AccountInfoDouble(ACCOUNT_MARGIN_FREE)/10000*LotsPercent)/koef_lot;
   if(dLot<0.01) dLot=0.01;
   return(dLot);
  }
//+------------------------------------------------------------------+
double NormalizeLot(double lot_value) //      |
//+------------------------------------------------------------------+
  {
   double lot_min=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);  //    
   double lot_max=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);
   double lot_step=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);

   if(lot_value <= lot_min) lot_value = lot_min;            //  
   else if(lot_value >= lot_max) lot_value = lot_max;       // 
   else lot_value = MathFloor(lot_value/lot_step)*lot_step; //    

   return(NormalizeDouble(lot_value,2)); // 
  }
//+------------------------------------------------------------------+  
